---------------------
PatchSet 307 
Date: 2000/05/16 18:53:50
Author: hno
Branch: hno-devel
Tag: (none) 
Log:
Syncronized with modio

Members: 
	ChangeLog:1.1.1.3.6.5.2.2->1.1.1.3.6.5.2.3 
	acconfig.h:1.1.1.3.6.5.2.1->1.1.1.3.6.5.2.2 
	configure.in:1.1.1.3.6.7.2.7->1.1.1.3.6.7.2.8 
	auth_modules/MSNT/README:1.1.1.1->1.1.1.1.6.1 
	auth_modules/MSNT/msntauth-v1.0.lsm:1.1.1.1->1.1.1.1.6.1 
	auth_modules/MSNT/smbauth.c:1.1.1.1->1.1.1.1.6.1 
	errors/Estonian/ERR_ACCESS_DENIED:1.1.1.1->1.1.1.1.8.1 
	errors/Estonian/ERR_CACHE_ACCESS_DENIED:1.1.1.1->1.1.1.1.8.1 
	errors/Estonian/ERR_CACHE_MGR_ACCESS_DENIED:1.1.1.1->1.1.1.1.8.1 
	errors/Estonian/ERR_CANNOT_FORWARD:1.1.1.1->1.1.1.1.8.1 
	errors/Estonian/ERR_CONNECT_FAIL:1.1.1.1->1.1.1.1.8.1 
	errors/Estonian/ERR_DNS_FAIL:1.1.1.1->1.1.1.1.8.1 
	errors/Estonian/ERR_FORWARDING_DENIED:1.1.1.1->1.1.1.1.8.1 
	errors/Estonian/ERR_FTP_DISABLED:1.1.1.1->1.1.1.1.8.1 
	errors/Estonian/ERR_FTP_FAILURE:1.1.1.1->1.1.1.1.8.1 
	errors/Estonian/ERR_FTP_FORBIDDEN:1.1.1.1->1.1.1.1.8.1 
	errors/Estonian/ERR_FTP_NOT_FOUND:1.1.1.1->1.1.1.1.8.1 
	errors/Estonian/ERR_FTP_PUT_ERROR:1.1.1.1->1.1.1.1.8.1 
	errors/Estonian/ERR_FTP_UNAVAILABLE:1.1.1.1->1.1.1.1.8.1 
	errors/Estonian/ERR_INVALID_REQ:1.1.1.1->1.1.1.1.8.1 
	errors/Estonian/ERR_INVALID_URL:1.1.1.1->1.1.1.1.8.1 
	errors/Estonian/ERR_LIFETIME_EXP:1.1.1.1->1.1.1.1.8.1 
	errors/Estonian/ERR_NO_RELAY:1.1.1.1->1.1.1.1.8.1 
	errors/Estonian/ERR_ONLY_IF_CACHED_MISS:1.1.1.1->1.1.1.1.8.1 
	errors/Estonian/ERR_READ_ERROR:1.1.1.1->1.1.1.1.8.1 
	errors/Estonian/ERR_READ_TIMEOUT:1.1.1.1->1.1.1.1.8.1 
	errors/Estonian/ERR_SHUTTING_DOWN:1.1.1.1->1.1.1.1.8.1 
	errors/Estonian/ERR_SOCKET_FAILURE:1.1.1.1->1.1.1.1.8.1 
	errors/Estonian/ERR_TOO_BIG:1.1.1.1->1.1.1.1.6.1 
	errors/Estonian/ERR_UNSUP_REQ:1.1.1.1->1.1.1.1.8.1 
	errors/Estonian/ERR_URN_RESOLVE:1.1.1.1->1.1.1.1.8.1 
	errors/Estonian/ERR_WRITE_ERROR:1.1.1.1->1.1.1.1.8.1 
	errors/Estonian/ERR_ZERO_SIZE_OBJECT:1.1.1.2->1.1.1.2.8.1 
	errors/Japanese/ERR_SHUTTING_DOWN:1.1.1.1->1.1.1.1.8.1 
	errors/Japanese/ERR_TOO_BIG:1.1.1.1->1.1.1.1.6.1 
	errors/Simplify_Chinese/ERR_ACCESS_DENIED:1.1->1.1.6.1 
	errors/Simplify_Chinese/ERR_CACHE_ACCESS_DENIED:1.1->1.1.6.1 
	errors/Simplify_Chinese/ERR_CACHE_MGR_ACCESS_DENIED:1.1->1.1.6.1 
	errors/Simplify_Chinese/ERR_CANNOT_FORWARD:1.1->1.1.6.1 
	errors/Simplify_Chinese/ERR_CONNECT_FAIL:1.1->1.1.6.1 
	errors/Simplify_Chinese/ERR_DNS_FAIL:1.1->1.1.6.1 
	errors/Simplify_Chinese/ERR_FORWARDING_DENIED:1.1->1.1.6.1 
	errors/Simplify_Chinese/ERR_FTP_DISABLED:1.1->1.1.6.1 
	errors/Simplify_Chinese/ERR_FTP_FAILURE:1.1->1.1.6.1 
	errors/Simplify_Chinese/ERR_FTP_FORBIDDEN:1.1->1.1.6.1 
	errors/Simplify_Chinese/ERR_FTP_NOT_FOUND:1.1->1.1.6.1 
	errors/Simplify_Chinese/ERR_FTP_PUT_CREATED:1.1->1.1.6.1 
	errors/Simplify_Chinese/ERR_FTP_PUT_ERROR:1.1->1.1.6.1 
	errors/Simplify_Chinese/ERR_FTP_PUT_MODIFIED:1.1->1.1.6.1 
	errors/Simplify_Chinese/ERR_FTP_UNAVAILABLE:1.1->1.1.6.1 
	errors/Simplify_Chinese/ERR_INVALID_REQ:1.1->1.1.6.1 
	errors/Simplify_Chinese/ERR_INVALID_URL:1.1->1.1.6.1 
	errors/Simplify_Chinese/ERR_LIFETIME_EXP:1.1->1.1.6.1 
	errors/Simplify_Chinese/ERR_NO_RELAY:1.1->1.1.6.1 
	errors/Simplify_Chinese/ERR_ONLY_IF_CACHED_MISS:1.1->1.1.6.1 
	errors/Simplify_Chinese/ERR_READ_ERROR:1.1->1.1.6.1 
	errors/Simplify_Chinese/ERR_READ_TIMEOUT:1.1->1.1.6.1 
	errors/Simplify_Chinese/ERR_SHUTTING_DOWN:1.1->1.1.6.1 
	errors/Simplify_Chinese/ERR_SOCKET_FAILURE:1.1->1.1.6.1 
	errors/Simplify_Chinese/ERR_TOO_BIG:1.1->1.1.6.1 
	errors/Simplify_Chinese/ERR_UNSUP_REQ:1.1->1.1.6.1 
	errors/Simplify_Chinese/ERR_URN_RESOLVE:1.1->1.1.6.1 
	errors/Simplify_Chinese/ERR_WRITE_ERROR:1.1->1.1.6.1 
	errors/Simplify_Chinese/ERR_ZERO_SIZE_OBJECT:1.1->1.1.6.1 
	errors/Simplify_Chinese/README:1.1->1.1.6.1 
	errors/Simplify_Chinese/generic:1.1->1.1.6.1 
	src/HttpReply.c:1.1.1.3.6.1->1.1.1.3.6.1.2.1 
	src/MemBuf.c:1.1.1.2.8.1->1.1.1.2.8.1.2.1 
	src/acl.c:1.1.1.3.10.5.2.3->1.1.1.3.10.5.2.4 
	src/asn.c:1.1.1.3.6.1.2.2->1.1.1.3.6.1.2.3 
	src/cache_cf.c:1.1.1.3.10.4.2.3->1.1.1.3.10.4.2.4 
	src/cache_manager.c:1.1.1.2.8.1->1.1.1.2.8.1.2.1 
	src/carp.c:1.1.1.1.8.1->1.1.1.1.8.1.2.1 
	src/cf.data.pre:1.1.1.3.10.6.2.5->1.1.1.3.10.6.2.6 
	src/client.c:1.1.1.3.6.1->1.1.1.3.6.1.2.1 
	src/client_db.c:1.1.1.3.6.1->1.1.1.3.6.1.2.1 
	src/client_side.c:1.1.1.3.10.7.2.5->1.1.1.3.10.7.2.6 
	src/delay_pools.c:1.1.1.3.10.3.2.2->1.1.1.3.10.3.2.3 
	src/dns.c:1.1.1.3.10.2->1.1.1.3.10.2.2.1 
	src/dns_internal.c:1.1.1.1.10.4.2.3->1.1.1.1.10.4.2.4 
	src/fqdncache.c:1.1.1.3.6.1->1.1.1.3.6.1.2.1 
	src/ftp.c:1.1.1.3.10.3->1.1.1.3.10.3.2.1 
	src/gopher.c:1.1.1.3.6.1->1.1.1.3.6.1.2.1 
	src/http.c:1.1.1.3.10.4.2.1->1.1.1.3.10.4.2.2 
	src/icmp.c:1.1.1.2.12.2->1.1.1.2.12.2.2.1 
	src/icp_v2.c:1.1.1.3.6.1->1.1.1.3.6.1.2.1 
	src/icp_v3.c:1.1.1.3.6.1->1.1.1.3.6.1.2.1 
	src/ident.c:1.1.1.3.6.1->1.1.1.3.6.1.2.1 
	src/ipcache.c:1.1.1.3.6.1->1.1.1.3.6.1.2.1 
	src/mib.txt:1.1.1.3->1.1.1.3.6.1 
	src/mime.c:1.1.1.3.6.1->1.1.1.3.6.1.2.1 
	src/neighbors.c:1.1.1.3.10.3.2.1->1.1.1.3.10.3.2.2 
	src/net_db.c:1.1.1.3.10.2.2.1->1.1.1.3.10.2.2.2 
	src/pinger.c:1.1.1.3.6.1->1.1.1.3.6.1.2.1 
	src/protos.h:1.1.1.3.10.8.2.5->1.1.1.3.10.8.2.6 
	src/snmp_agent.c:1.1.1.3.6.2.2.1->1.1.1.3.6.2.2.2 
	src/snmp_core.c:1.1.1.3.6.1->1.1.1.3.6.1.2.1 
	src/stat.c:1.1.1.3.10.4.2.2->1.1.1.3.10.4.2.3 
	src/store.c:1.1.1.3.10.8.2.4->1.1.1.3.10.8.2.5 
	src/store_client.c:1.1.1.3.10.4.2.4->1.1.1.3.10.4.2.5 
	src/store_dir.c:1.1.1.3.10.6.2.2->1.1.1.3.10.6.2.3 
	src/structs.h:1.1.1.3.10.8.2.6->1.1.1.3.10.8.2.7 
	src/test_cache_digest.c:1.1.1.1.8.1->1.1.1.1.8.1.2.1 
	src/tools.c:1.1.1.3.6.1->1.1.1.3.6.1.2.1 
	src/unlinkd.c:1.1.1.3.10.3.2.2->1.1.1.3.10.3.2.3 
	src/url.c:1.1.1.3.10.2.2.1->1.1.1.3.10.2.2.2 
	src/wccp.c:1.1.1.1.6.1->1.1.1.1.6.1.2.1 
	src/whois.c:1.1.1.2.8.1->1.1.1.2.8.1.2.1 
	src/fs/coss/store_io_coss.c:1.1.4.8.2.4->1.1.4.8.2.5 

Index: squid/ChangeLog
===================================================================
RCS file: /cvsroot/squid-sf//squid/ChangeLog,v
retrieving revision 1.1.1.3.6.5.2.2
retrieving revision 1.1.1.3.6.5.2.3
diff -u -r1.1.1.3.6.5.2.2 -r1.1.1.3.6.5.2.3
--- squid/ChangeLog	3 May 2000 19:00:00 -0000	1.1.1.3.6.5.2.2
+++ squid/ChangeLog	16 May 2000 18:53:50 -0000	1.1.1.3.6.5.2.3
@@ -80,6 +80,105 @@
 
 Changes to Squid-2.4.DEVEL1 ():
 
+Changes to Squid-2.3.STABLE3 (May 15, 2000):
+
+	- Fixed malloc linking problems on Solaris.  The configure
+	  script incorrectly set options for dlmalloc.
+	- Added a configure check to remove compiler optimization
+	  for GCC 2.95.x.
+	- Updated MSNT authenticator module.
+	- Updated Estonian error pages.
+	- Updated Japanese error pages.
+	- Fixed expires bug in httpReplyHdrCacheInit.  It was
+	  incorrectly setting expires based on max-age.  It was using
+	  the current time as a basis, instead of the response date.
+	- Fixed "USE_DNSSERVER" typos.
+	- Added a workaround for getpwnam() problems on Solaris.
+	  getpwnam() could fail if there are fewer than 256 FDs
+	  available.  This causes root to own some disk files.
+	- Added an 'offline_toggle' option via the cache manager.
+	- Added a 'minimum_object_size' option.  Files smaller than
+	  this size are not stored.
+	- Added 'passive_ftp' option to disable passive FTP transfers.
+	- Added 'wccp_version' option because some Cisco IOS versions
+	  require WCCP version 3.
+	- The 'client' program in ping mode (-g) now prints transfer
+	  throughput.
+	- Fixed logging of proxy auth username for redirected
+	  requests.
+	- Fixed bogus Age values for IMS requests.
+	- Fixed persistent connection timeout for client-side
+	  connections.  It was hard-coded to 15 seconds, now uses
+	  the 'pconn_timeout' value.
+	- Fixed up httpAcceptDefer.  It wasn't being used properly
+	  and caused high CPU usage when Squid gets close to the FD
+	  limit.
+	- Numerous delay_pools fixes and checks.
+	- Fixed SNMP coredumps from running snmpwalk.
+	- Added a check for errno == EPIPE in icmp.c when pinger uses
+	  a Unix socket instead of a UDP socket.
+	- Fixed ACL checklist memory initialization bugs.
+	- Cleaned up the MIB file.  Replaced contact information and
+	  checked description fields.
+	- Removed LRU reference_age hard-coded upper limit.
+	- Fixed async I/O FD leak.
+	- Made getMyHostname() more robust.
+	- Fixed domain list matching bug.  "x-foo.com" wasn't properly
+	  compared to ".foo.com" and confused splay tree ordering.
+	- Added a check for whitespace in hostnames and optionally
+	  strip whitespace if 'uri_whitespace' setting allows.
+	- Added status code and checking to ASN/whois queries.
+
+Changes to Squid-2.3.STABLE2 (Mar 2, 2000):
+
+	- Changed Copyright text.
+	- Changed configure so that some IRIX-6.4 hacks apply to
+	  all IRIX-6.* versions.
+	- Cleaned up HTML bugs in error pages.
+	- Told configure to check for netinet/if_ether.h, which
+	  is used in ARP ACL code, but might not be required.
+	- Added "Cookie" to known HTTP headers so it can be
+	  used in anonymizer configuration.
+	- Added optional TCP_REDIRECT log code for logging
+	  of 301/302 responses returned by Squid.
+	- Added a check for a currently running Squid process.
+	  If the pid file exists, and the pid is running,
+	  Squid complains and refuses to start another instance.
+	- Changed async I/O scope to PTHREAD_SCOPE_PROCESS for
+	  IRIX.
+	- Fixed a bug with the PURGE method.  The purge enable
+	  flag was not getting cleared during reconfigure.
+	  Also required PURGE method to be used in http_access
+	  list before enabling.
+	- Fixed async I/O assertions for file open errors.
+	- Fixed internal DNS assertion when unpacking truncated
+	  messages.
+	- Fixed anonymize_headers bug that caused all headers
+	  to be allowed after a reconfigure.
+	- Fixed an access denied bug for accelerator-only installations.
+	- Fixed internal DNS initialization so that it uses
+	  'dns_nameservers' settings in squid.conf if set.
+	- Fixed 'maxconn' ACL bug that caused it to work backwards
+	  (Pedro Ribeiro).
+	- Fixed syslog bug for daemon mode on Linux.
+	- Fixed 'http_port' parsing bugs.
+	- Fixed internal DNS byte ordering bugs for PTR queries.
+	- Fixed internal DNS queue getting stuck during periods
+	  of low activity (Henrik).
+	- Fixed byte ordering bugs for parsing EPLF FTP listings
+	  on 64-bit systems.
+	- Fixed 'request_body_max_size' bug that caused all
+	  POST, PUT requests to be denied if max size is set
+	  to zero.
+	- Fixed 'redirector_access' bug when using 'myport' ACLs.
+	- Fixed CARP neighbor selection bugs for down peers.
+	- Added 'client_persistent_connections' and
+	  'server_persistent_connections' flags to disable persistent
+	  connections for clients and servers.
+	- Fixed access logging bug that caused many requests to be
+	  logged as TCP_MISS.
+	- Added some bounds checking to delay pools code.
+
 Changes to Squid-2.3.STABLE1 (Jan 9, 2000):
 
 	- Updated PAM authentication module from Henrik Nordstrom.
@@ -310,7 +409,7 @@
 	- Added 'peer_connect_timeout' squid.conf option.
 	- Added 'redirector_bypass' squid.conf option.
 	- Added RFC 2518 (WEBDAV) request methods.
-
+	
 Changes to Squid-2.2 (April 19, 1999):
 
 	- Removed all SNMP specific ACL code
Index: squid/acconfig.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/Attic/acconfig.h,v
retrieving revision 1.1.1.3.6.5.2.1
retrieving revision 1.1.1.3.6.5.2.2
diff -u -r1.1.1.3.6.5.2.1 -r1.1.1.3.6.5.2.2
--- squid/acconfig.h	23 Apr 2000 09:55:37 -0000	1.1.1.3.6.5.2.1
+++ squid/acconfig.h	16 May 2000 18:53:51 -0000	1.1.1.3.6.5.2.2
@@ -20,7 +20,7 @@
  *
  */
 @ TOP @
-/* $Id: acconfig.h,v 1.1.1.3.6.5.2.1 2000/04/23 09:55:37 hno Exp $ */
+/* $Id: acconfig.h,v 1.1.1.3.6.5.2.2 2000/05/16 18:53:51 hno Exp $ */
 
 /*********************************
  * START OF CONFIGURABLE OPTIONS *
@@ -268,19 +268,11 @@
 #undef ATHY_COMPRESSION
 
 /*
- * Use DISKD
- */
-#undef USE_DISKD
-
-/*
  * Define this if unlinkd is required
  * (strongly recommended for ufs storage type)
  */
 #undef USE_UNLINKD
 
-/* Define if you want to set the COSS membuf size */
-#undef COSS_MEMBUF_SZ
-
 /*
  * message type for message queues
  */
Index: squid/configure.in
===================================================================
RCS file: /cvsroot/squid-sf//squid/configure.in,v
retrieving revision 1.1.1.3.6.7.2.7
retrieving revision 1.1.1.3.6.7.2.8
diff -u -r1.1.1.3.6.7.2.7 -r1.1.1.3.6.7.2.8
--- squid/configure.in	14 May 2000 23:22:19 -0000	1.1.1.3.6.7.2.7
+++ squid/configure.in	16 May 2000 18:53:51 -0000	1.1.1.3.6.7.2.8
@@ -3,13 +3,13 @@
 dnl
 dnl  Duane Wessels, wessels@nlanr.net, February 1996 (autoconf v2.9)
 dnl
-dnl  $Id: configure.in,v 1.1.1.3.6.7.2.7 2000/05/14 23:22:19 hno Exp $
+dnl  $Id: configure.in,v 1.1.1.3.6.7.2.8 2000/05/16 18:53:51 hno Exp $
 dnl
 dnl
 dnl
 AC_INIT(src/main.c)
 AC_CONFIG_HEADER(include/autoconf.h)
-AC_REVISION($Revision: 1.1.1.3.6.7.2.7 $)dnl
+AC_REVISION($Revision: 1.1.1.3.6.7.2.8 $)dnl
 AC_PREFIX_DEFAULT(/usr/local/squid)
 AC_CONFIG_AUX_DIR(cfgaux)
 
@@ -149,6 +149,8 @@
 	i386-*-solaris2.*)
 		echo "Enabling dlmalloc for $host"
 		use_dlmalloc="yes"
+		LIBDLMALLOC="libdlmalloc.a"
+		LIB_MALLOC="-L../lib -ldlmalloc"
 		;;
     esac
 fi
@@ -1058,6 +1060,18 @@
 		;;
 esac
 
+# Remove optimization for GCC 2.95.[12]
+# gcc -O[2] on *BSD and Linux (x86) causes pointers to magically become NULL
+if test "$GCC" = "yes"; then
+	GCCVER=`$CC -v 2>&1 | awk '$2 ==  "version" {print $3}'`
+	case "$GCCVER" in
+	[2.95.[12]])
+		echo "Removing -O for gcc on $host with GCC $GCCVER"
+		CFLAGS="`echo $CFLAGS | sed -e 's/-O[[0-9]]*//'`"
+		;;
+	esac
+fi
+
 # Recommended by Balint Nagy Endre <bne@CareNet.hu>
 case "$host" in
 	*-univel-sysv4.2MP)
Index: squid/auth_modules/MSNT/README
===================================================================
RCS file: /cvsroot/squid-sf//squid/auth_modules/MSNT/Attic/README,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.6.1
diff -u -r1.1.1.1 -r1.1.1.1.6.1
--- squid/auth_modules/MSNT/README	26 Jan 2000 03:25:00 -0000	1.1.1.1
+++ squid/auth_modules/MSNT/README	16 May 2000 18:53:51 -0000	1.1.1.1.6.1
@@ -1,11 +1,10 @@
 
-MSNT Auth v1.0
+MSNT Auth v1.1
 Squid web proxy Authentication module
 Antonino Iannella, Stellar-X Pty Ltd
-Mon Oct 18 11:44:50 CST 1999
+Mon Apr 10 22:47:33 CST 2000
 _____________________________________
 
-
 This is a simple authentication module for the Squid proxy server
 to authenticate users on an NT domain.
 
@@ -13,35 +12,114 @@
 and Richard Sharpe. This version is sourced from the Pike
 authentication module by William Welliver (hwellive@intersil.com).
 
-Its use is simple. It accepts a username and password on standard input
+Usage is simple. It accepts a username and password on standard input
 and will return OK if the username/password is valid for the domain,
 or ERR if there was some problem.
 
 You will need to modify the NT server definitions for your site;
-this is the NT PDC server and domain to authenticate to.
-This is done in smbauth.c.
+this is the NT server and NT domain to authenticate to.
+This is done in sitedef.h.
+
+Usernames can now be explicitly denied. See below for details.
+
+This is released under the GNU General Public License and
+is available from http://stellarx.tripod.com.
+
+Site customisation -
+
+Change the following lines in sitedef.h.
+Set the Primary Domain Controller, the backup (if different from the PDC),
+and the NT domain.
+
+  #define PRIMARY_DC "my_pdc"
+  #define BACKUP_DC  "my_bdc"
+  #define NTDOMAIN   "my_domain"
 
-Msntauth is released under the GNU General Public License and
-is available from http://members.tripod.com/~antonino.
+Denying Users -
+
+Users who are not allowed to access the web proxy can be added to
+the denied user list. This list is read every minute, or when
+msntauth receives a SIGHUP signal.
+
+The denied user file is /usr/local/squid/etc/denyusers. This may be
+changed in the DENYUSERS line in denyusers.c. The denied user file
+contains a list of usernames in no particular structure or form.
+If the file does not exist, no users are denied.
+The file must be readable by the web proxy user.
+Msntauth will send syslog messages at LOG_USER priority.
 
 Installation -
 
-Modify smbauth.c as needed.
-type 'make', then 'make install', then 'make clean'.
-The default is to install 'msntauth' into /usr/local/squid/bin.
+Type 'make', then 'make install', then 'make clean'.
+To avoid using the makefile, it may compile with
+
+  gcc -O2 -s -o msntauth *.c
+
+The default is to install 'msntauth' into /usr/local/sbin.
+
+Refer to Squid documentation for the required changes to squid.conf.
+You will need to set the following lines to enable authentication for
+your access list -
+
+  acl <yourACL> proxy_auth REQUIRED
+  http_access allow <yourACL>
+
+You will need to specify the absolute path to msntauth in the 
+authenticate_program directive, and check the authenticate_children
+and authenticate_ttl.
 
 Compilation issues -
 
 The Makefile assumes that GCC is in the current PATH.
-Msntauth is known to compile properly on Redhat Linux 6, FreeBSD 3.1
+Msntauth is known to compile properly on Redhat Linux 6, and FreeBSD 3.1
 without problems. Other operating systems are untested,
 but use a recent copy of the GNU C compiler.
 Smbencrypt.c has the '#include <sys/vfs.h>' line commented out.
 Remove the comments for S5R4 systems, like Solaris.
 
+When compiling under Solaris, the socket libraries must be linked to.
+In the Makefile CFLAGS line, add to the end
+
+  -Dsolaris -lnsl -lsocket
+
+Testing -
+
+I strongly urge that Msntauth is tested prior to being used in a 
+production environment. It may behave differently on different platforms.
+To test it, run it from the command line. Enter username and password
+pairs separated by a space. Press ENTER to get an OK or ERR message.
+Make sure pressing <CTRL><D> behaves the same as a carriage return.
+Make sure pressing <CTRL><C> aborts the program.
+
+Test that entering no details does not result in an OK or ERR message.
+Test that entering an invalid username and password results in an ERR message.
+Note that if NT guest user access is allowed on the PDC, an OK message
+may be returned instead of ERR.
+Test that entering an valid username and password results in an OK message.
+Test that entering a guest username and password returns the correct
+response for the site's access policy.
+
+If the above didn't work as expected, you may need to modify the main()
+function in smbauth.c. Inform the maintainer of any problems.
+
 Contact details -
 
 To contact the maintainer of this package, email Antonino Iannella
-on antonino@usa.net. The latest version may be found on
-http://members.tripod.com/~antonino.
+on stellarx@usa.net or antonino.iannella@usa.net.
+The latest version may be found on http://stellarx.tripod.com.
+
+Reported problem -
+
+For an unknown username, Msntauth returns OK.
+This is because the PDC returns guest access for unknown users,
+even if guest access is disabled.
+This problem was reported by Mr Vadim Popov (vap@iilsr.minsk.by).
+I am not able to replicate this.
+
+The tested environment consisted of PDC on Windows NT 4, SP 6.
+Squid 2.3 and Msntauth was tested on SuSe, RedHat, and Debian Linux.
+A fix was provided in case you have this problem.
+Apply the provided patch before compiling, using
+
+  patch smblib.c < smblib.c.patch
 
Index: squid/auth_modules/MSNT/msntauth-v1.0.lsm
===================================================================
RCS file: /cvsroot/squid-sf//squid/auth_modules/MSNT/Attic/msntauth-v1.0.lsm,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.6.1
diff -u -r1.1.1.1 -r1.1.1.1.6.1
--- squid/auth_modules/MSNT/msntauth-v1.0.lsm	26 Jan 2000 03:25:00 -0000	1.1.1.1
+++ squid/auth_modules/MSNT/msntauth-v1.0.lsm	16 May 2000 18:53:51 -0000	1.1.1.1.6.1
@@ -1,13 +1,13 @@
 Begin3
 Title:         msntauth 
-Version:       1.0 
-Entered-date:  17SEP99 
+Version:       1.1 
+Entered-date:  12APR00 
 Description:   Squid web proxy NT domain authentication module 
 Keywords:      Squid WWW proxy SMB NT domain authentication module source
-Author:         antonino@usa.net (Antonino Iannella)
-Maintained-by:  antonino@usa.net (Antonino Iannella)
+Author:         antonino.iannella@usa.net (Antonino Iannella)
+Maintained-by:  antonino.iannella@usa.net (Antonino Iannella)
 Primary-site:   sunsite.unc.edu /pub/Linux/system/network/misc
-		msntauth-v1.0.tgz
-Original-site:  http://members.tripod.com/~antonino
+		msntauth-v1.1.tgz
+Original-site:  http://stellarx.tripod.com
 Copying-policy: GPL
 End
Index: squid/auth_modules/MSNT/smbauth.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/auth_modules/MSNT/Attic/smbauth.c,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.6.1
diff -u -r1.1.1.1 -r1.1.1.1.6.1
--- squid/auth_modules/MSNT/smbauth.c	26 Jan 2000 03:25:00 -0000	1.1.1.1
+++ squid/auth_modules/MSNT/smbauth.c	16 May 2000 18:53:51 -0000	1.1.1.1.6.1
@@ -2,12 +2,12 @@
 /*
   msntauth
 
-  Modified to act as a Squid authenticator
+  Modified to act as a Squid authenticator module.
   Removed all Pike stuff.
   Returns OK for a successful authentication, or ERR upon error.
 
   Antonino Iannella, Camtech SA Pty Ltd
-  Thu Sep 16 15:25:28 CST 1999
+  Mon Apr 10 22:24:26 CST 2000
 
   Uses code from -
     Andrew Tridgell 1997
@@ -32,47 +32,78 @@
 */
 
 #include <stdio.h>
+#include <signal.h>
+#include <sys/time.h>
+#include "sitedef.h"
 
-/* You must specifiy these for your site! */
-
-#define PRIMARY_DC "my_pdc"
-#define BACKUP_DC  "my_bdc"
-#define NTDOMAIN   "my_domain"
+extern void Checkforchange();       /* For signal() to find the function */
 
 /* Main program for simple authentication.
-   This code could probably be better, might be
-   susceptible to buffer overflows. */
+   Reads the denied user file. Sets alarm timer.
+   Scans and checks for Squid input, and attempts to validate the user.
+*/
 
 int main()
 {
   char username[256];
   char password[256];
   char wstr[256];
+  struct itimerval TimeOut;
+
+  /* Read denied user file. If it fails there is a serious problem.
+     Check syslog messages. Deny all users while in this state.
+     The process should then be killed. */
+
+  if (Read_denyusers() == 1)
+  {
+     while (1)
+     {
+       fgets(wstr, 255, stdin);
+       puts("ERR");
+       fflush(stdout);
+     }
+  }
+
+  /* An alarm timer is used to check the denied user file for changes
+     every minute. Reload the file if it has changed. */ 
+
+  TimeOut.it_interval.tv_sec = 60;
+  TimeOut.it_interval.tv_usec = 0;
+  TimeOut.it_value.tv_sec = 60;
+  TimeOut.it_value.tv_usec = 0;
+  setitimer(ITIMER_REAL, &TimeOut, 0);
+  signal(SIGALRM, Checkforchange);
+  signal(SIGHUP, Checkforchange);
 
   while (1)
   {
-    // Read whole line from standard input. Terminate on break.
+    /* Read whole line from standard input. Terminate on break. */
     if (fgets(wstr, 255, stdin) == NULL)    
        break;
 
-    // Clear any current settings
+    /* Clear any current settings */
     username[0] = '\0';
     password[0] = '\0';
-    sscanf(wstr, "%s %s", username, password);          // Extract parameters
+    sscanf(wstr, "%s %s", username, password);     /* Extract parameters */
 
-    // Check for invalid or blank entries
+    /* Check for invalid or blank entries */
     if ((username[0] == '\0') || (password[0] == '\0'))
-    {
+  {
        puts("ERR");
        fflush(stdout);
        continue;
     }
 
+    if (Check_user(username) == 1)            /* Check if user is denied */
+        puts("ERR");
+    else
+    {
     if (Valid_User(username, password, PRIMARY_DC, BACKUP_DC, NTDOMAIN) == 0)
        puts("OK");
     else
        puts("ERR");
-       
+  }
+
     fflush(stdout);
   }
   
Index: squid/errors/Estonian/ERR_ACCESS_DENIED
===================================================================
RCS file: /cvsroot/squid-sf//squid/errors/Estonian/ERR_ACCESS_DENIED,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.8.1
diff -u -r1.1.1.1 -r1.1.1.1.8.1
--- squid/errors/Estonian/ERR_ACCESS_DENIED	26 Jan 2000 03:21:47 -0000	1.1.1.1
+++ squid/errors/Estonian/ERR_ACCESS_DENIED	16 May 2000 18:53:51 -0000	1.1.1.1.8.1
@@ -18,5 +18,5 @@
 Juurdep&auml;&auml;su kontrolli konfiguratsioon blokeerib teie p&auml;ringut.
 Kui te arvate, et blokeering pole &otilde;ige, kontakteeruge palun teenuse pakkujaga.
 </UL>
-</P>
+<P>Teie teenusepakkuja aadress on <A HREF="mailto:%w">%w</A>.
 
Index: squid/errors/Estonian/ERR_CACHE_ACCESS_DENIED
===================================================================
RCS file: /cvsroot/squid-sf//squid/errors/Estonian/ERR_CACHE_ACCESS_DENIED,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.8.1
diff -u -r1.1.1.1 -r1.1.1.1.8.1
--- squid/errors/Estonian/ERR_CACHE_ACCESS_DENIED	26 Jan 2000 03:21:47 -0000	1.1.1.1
+++ squid/errors/Estonian/ERR_CACHE_ACCESS_DENIED	16 May 2000 18:53:51 -0000	1.1.1.1.8.1
@@ -1,9 +1,9 @@
 <HTML><HEAD>
-<TITLE>VIGA: Cache kasutamine blokeeritud</TITLE>
+<TITLE>VIGA: Vahemälu serveri kasutamine blokeeritud</TITLE>
 </HEAD>
 <BODY>
 <H1>VIGA</H1>
-<H2>Cache kasutamine keelatud</H2>
+<H2>Vahemälu serveri kasutamine keelatud</H2>
 <HR>
 <P>
 Sooritades p&auml;ringut URLile
@@ -13,7 +13,7 @@
 <UL>
 <LI>
 <STRONG>
-Cache kasutamine keelatud.
+Vahemälu serveri kasutamine keelatud.
 </STRONG>
 </UL>
 </P>
@@ -26,7 +26,7 @@
 <P>
 Autoriseerimiseks on teil vaja brauserit mis toetab HTTP/1.1 standardit,
 nagu Netscape versioon 2.0 v&otilde;i uuem, v&otilde;i MS Internet Explorer
-3.0. Palun kontakteeruge <A HREF="mailto:%w">cache administraatoriga</a>,
+3.0. Palun kontakteeruge <A HREF="mailto:%w">vahemälu serveri administraatoriga</a>,
 kui teil on probleeme autoriseerimisega v&otilde;i
 <A HREF="http://%h/cgi-bin/chpasswd.cgi\">vahetage/a> oma parool.
 </P>
Index: squid/errors/Estonian/ERR_CACHE_MGR_ACCESS_DENIED
===================================================================
RCS file: /cvsroot/squid-sf//squid/errors/Estonian/ERR_CACHE_MGR_ACCESS_DENIED,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.8.1
diff -u -r1.1.1.1 -r1.1.1.1.8.1
--- squid/errors/Estonian/ERR_CACHE_MGR_ACCESS_DENIED	26 Jan 2000 03:21:47 -0000	1.1.1.1
+++ squid/errors/Estonian/ERR_CACHE_MGR_ACCESS_DENIED	16 May 2000 18:53:51 -0000	1.1.1.1.8.1
@@ -1,9 +1,9 @@
 <HTML><HEAD>
-<TITLE>VIGA: Cache haldaja kasutamine blokeeritud</TITLE>
+<TITLE>VIGA: Vahemälu serveri haldaja kasutamine blokeeritud</TITLE>
 </HEAD>
 <BODY>
 <H1>VIGA</H1>
-<H2>Cache haldaja kasutamine blokeeritud</H2>
+<H2>Vahemälu serveri haldaja kasutamine blokeeritud</H2>
 <HR>
 <P>
 Sooritades p&auml;ringut URLile
@@ -13,19 +13,19 @@
 <UL>
 <LI>
 <STRONG>
-Cache haldaja kasutamine keelatud.
+Vahemälu serveri haldaja kasutamine keelatud.
 </STRONG>
 </UL>
 </P>
 
 <P>Vabandust, teil pole &otilde;igust p&auml;ringule:
 <PRE>    %U</PRE>
-sellele cache haldajale, kuni te pole l&auml;binud autoriseerimist.
+sellele vahemälu serveri haldajale, kuni te pole l&auml;binud autoriseerimist.
 </P>
 
 <P> Autoriseerimiseks on teil vaja brauserit mis toetab HTTP/1.1 standardit,
 nagu Netscape versioon 2.0 v&otilde;i uuem, v&otilde;i MS Internet Explorer
-3.0. Palun kontakteeruge <A HREF="mailto:%w">cache administraatoriga</a>,
+3.0. Palun kontakteeruge <A HREF="mailto:%w">vahemälu serveri administraatoriga</a>,
 kui teil on probleeme autoriseerimisega v&otilde;i kui te <em>olete</em>
-administraator, lugege Squidi dokumentatsiooni cache haldaja interfeisi kohta
-ja kontrollige cache logi vea t&auml;psema kirjelduse saamiseks.</P>
+administraator, lugege Squidi dokumentatsiooni vahemälu serveri haldaja interfeisi kohta
+ja kontrollige vahemälu serveri logi t&auml;psema veakirjelduse saamiseks.</P>
Index: squid/errors/Estonian/ERR_CANNOT_FORWARD
===================================================================
RCS file: /cvsroot/squid-sf//squid/errors/Estonian/ERR_CANNOT_FORWARD,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.8.1
diff -u -r1.1.1.1 -r1.1.1.1.8.1
--- squid/errors/Estonian/ERR_CANNOT_FORWARD	26 Jan 2000 03:21:47 -0000	1.1.1.1
+++ squid/errors/Estonian/ERR_CANNOT_FORWARD	16 May 2000 18:53:51 -0000	1.1.1.1.8.1
@@ -18,10 +18,10 @@
 
 <P>
 P&auml;ringut ei &otilde;nnestunud edastada ei originaali serverile ega
-&uuml;helegi vanem cache serverile. Ilmselt on p&otilde;hjus:
+&uuml;helegi vanem vahemälu serverile. Ilmselt on p&otilde;hjus:
 <UL>
-<LI>Cache administraator ei v&otilde;imalda teha otseseid p&auml;ringuid
+<LI>Vahemälu serveri administraator ei v&otilde;imalda teha otseseid p&auml;ringuid
 originaali serverile ja
-<LI>K&otilde;ik kirjeldatud vanem vanem cached on hetkel k&auml;ttesaamatud.
+<LI>K&otilde;ik kirjeldatud vanem vahemälu serverid on hetkel k&auml;ttesaamatud.
 </UL>
-</P>
+<P>Teie teenusepakkuja aadress on <A HREF="mailto:%w">%w</A>.
Index: squid/errors/Estonian/ERR_CONNECT_FAIL
===================================================================
RCS file: /cvsroot/squid-sf//squid/errors/Estonian/ERR_CONNECT_FAIL,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.8.1
diff -u -r1.1.1.1 -r1.1.1.1.8.1
--- squid/errors/Estonian/ERR_CONNECT_FAIL	26 Jan 2000 03:21:47 -0000	1.1.1.1
+++ squid/errors/Estonian/ERR_CONNECT_FAIL	16 May 2000 18:53:51 -0000	1.1.1.1.8.1
@@ -23,4 +23,4 @@
 <P>
 Server v&otilde;i arvutiv&otilde;rk ei t&ouml;&ouml;ta. Palun korrake
 p&auml;ringut.
-</P>
+<P>Teie teenusepakkuja aadress on <A HREF="mailto:%w">%w</A>.
Index: squid/errors/Estonian/ERR_DNS_FAIL
===================================================================
RCS file: /cvsroot/squid-sf//squid/errors/Estonian/ERR_DNS_FAIL,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.8.1
diff -u -r1.1.1.1 -r1.1.1.1.8.1
--- squid/errors/Estonian/ERR_DNS_FAIL	26 Jan 2000 03:21:47 -0000	1.1.1.1
+++ squid/errors/Estonian/ERR_DNS_FAIL	16 May 2000 18:53:51 -0000	1.1.1.1.8.1
@@ -22,8 +22,7 @@
 <P>
 Mis t&auml;hendab:
 <PRE>
- Cache ei suutnud lahendada URLis antud hosti nime. Palun kontrollige
+ Vahemälu server ei suutnud lahendada URLis antud hosti nime. Palun kontrollige
  aadressi korrektsust.
 </PRE>
-</P>
-
+<P>Teie teenuseVahemälu serve aadress on <A HREF="mailto:%w">%w</A>.
Index: squid/errors/Estonian/ERR_FORWARDING_DENIED
===================================================================
RCS file: /cvsroot/squid-sf//squid/errors/Estonian/ERR_FORWARDING_DENIED,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.8.1
diff -u -r1.1.1.1 -r1.1.1.1.8.1
--- squid/errors/Estonian/ERR_FORWARDING_DENIED	26 Jan 2000 03:21:47 -0000	1.1.1.1
+++ squid/errors/Estonian/ERR_FORWARDING_DENIED	16 May 2000 18:53:51 -0000	1.1.1.1.8.1
@@ -17,6 +17,6 @@
 </UL>
 
 <P>
-Meie cache ei edasta teie p&auml;ringut, kuna ta kasutab andmete edastamisel
-ainult naaber cache meetodit. Ilmselt on %i vigaselt konfigureeritud cache.
-</P>
+Meie vahemälu server ei edasta teie p&auml;ringut, kuna ta kasutab andmete edastamisel
+ainult naaber vahemälu serverite meetodit. Ilmselt on %i vigaselt konfigureeritud vahemälu server.
+<P>Teie teenusepakkuja aadress on <A HREF="mailto:%w">%w</A>.
Index: squid/errors/Estonian/ERR_FTP_DISABLED
===================================================================
RCS file: /cvsroot/squid-sf//squid/errors/Estonian/ERR_FTP_DISABLED,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.8.1
diff -u -r1.1.1.1 -r1.1.1.1.8.1
--- squid/errors/Estonian/ERR_FTP_DISABLED	26 Jan 2000 03:21:47 -0000	1.1.1.1
+++ squid/errors/Estonian/ERR_FTP_DISABLED	16 May 2000 18:53:51 -0000	1.1.1.1.8.1
@@ -17,5 +17,5 @@
 </UL>
 
 <P>
-See cache ei toeta FTPd.
-</P>
+See vahemälu server ei toeta FTPd.
+<P>Teie teenusepakkuja aadress on <A HREF="mailto:%w">%w</A>.
